Star Rating
This tutorial shows you how to build an interactive SVG star rating cell using editorFactory and rendererFactory, with hover preview and keyboard shortcuts - no external libraries required.
import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';import { editorFactory } from 'handsontable/editors';import { rendererFactory } from 'handsontable/renderers';
// Register all Handsontable's modules.registerAllModules();
/* start:skip-in-preview */const data = [ { product: 'Dashboard Pro', category: 'Analytics', rating: 5, reviews: 342, price: 49 }, { product: 'Form Builder', category: 'Tools', rating: 4, reviews: 218, price: 29 }, { product: 'Chart Engine', category: 'Analytics', rating: 3, reviews: 156, price: 39 }, { product: 'Auth Module', category: 'Security', rating: 5, reviews: 89, price: 19 }, { product: 'File Manager', category: 'Storage', rating: 2, reviews: 64, price: 15 }, { product: 'Email Service', category: 'Communication', rating: 4, reviews: 275, price: 25 }, { product: 'Search Index', category: 'Tools', rating: 1, reviews: 31, price: 35 }, { product: 'Cache Layer', category: 'Infra', rating: 4, reviews: 112, price: 20 },];/* end:skip-in-preview */// Get the DOM element with the ID 'example1' where the Handsontable will be renderedconst container = document.querySelector('#example1');const starSvg = '<svg width="1em" height="1em" viewBox="0 0 24 24" fill="currentColor"><path d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"/></svg>';
const cellDefinition = { renderer: rendererFactory(({ td, value }) => { td.innerHTML = `<div class="rating-cell">${Array.from( { length: 5 }, (_, index) => `<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>` ).join('')}</div>`; }), validator: (value, callback) => { value = parseInt(value); callback(value >= 0 && value <= 100); }, editor: editorFactory({ shortcuts: [ { keys: [['1'], ['2'], ['3'], ['4'], ['5']], callback: (editor, _event) => { editor.setValue(_event.key); }, }, { keys: [['ArrowRight']], callback: (editor, _event) => { if (parseInt(editor.value) < 5) { editor.setValue(parseInt(editor.value) + 1); } }, }, { keys: [['ArrowLeft']], callback: (editor, _event) => { if (parseInt(editor.value) > 1) { editor.setValue(parseInt(editor.value) - 1); } }, }, ], init(editor) { editor.input = editor.hot.rootDocument.createElement('DIV'); editor.input.classList.add('rating-editor'); }, afterInit(editor) { editor.input.addEventListener('mouseover', (event) => { const star = event.target.closest('.rating-star');
if (star?.dataset.value && parseInt(editor.value) !== parseInt(star.dataset.value)) { editor.setValue(star.dataset.value); } }); editor.input.addEventListener('mousedown', () => { editor.finishEditing(); }); }, render(editor) { editor.input.innerHTML = Array.from( { length: 5 }, (_, index) => `<span data-value="${index + 1}" class="rating-star ${index < editor.value ? 'active' : ''}${ index + 1 === parseInt(editor.value) ? ' current' : '' }">${starSvg}</span>` ).join(''); }, }),};
// Define configuration options for the Handsontableconst hotOptions = { data, colHeaders: ['Product', 'Category', 'Rating', 'Reviews', 'Price'], autoRowSize: true, rowHeaders: true, height: 'auto', width: '100%', autoWrapRow: true, headerClassName: 'htLeft', columns: [ { data: 'product', type: 'text', width: 240 }, { data: 'category', type: 'text', width: 120 }, { data: 'rating', width: 150, ...cellDefinition }, { data: 'reviews', type: 'numeric', width: 80 }, { data: 'price', type: 'numeric', width: 80 }, ], licenseKey: 'non-commercial-and-evaluation',};
// Initialize the Handsontable instance with the specified configuration options// eslint-disable-next-line no-unused-varsconst hot = new Handsontable(container, hotOptions);import Handsontable from "handsontable/base";import { registerAllModules } from "handsontable/registry";import { CellProperties } from "handsontable/settings";import { editorFactory } from "handsontable/editors";import { rendererFactory } from "handsontable/renderers";// Register all Handsontable's modules.registerAllModules();
/* start:skip-in-preview */const data = [ { product: "Dashboard Pro", category: "Analytics", rating: 5, reviews: 342, price: 49 }, { product: "Form Builder", category: "Tools", rating: 4, reviews: 218, price: 29 }, { product: "Chart Engine", category: "Analytics", rating: 3, reviews: 156, price: 39 }, { product: "Auth Module", category: "Security", rating: 5, reviews: 89, price: 19 }, { product: "File Manager", category: "Storage", rating: 2, reviews: 64, price: 15 }, { product: "Email Service", category: "Communication", rating: 4, reviews: 275, price: 25 }, { product: "Search Index", category: "Tools", rating: 1, reviews: 31, price: 35 }, { product: "Cache Layer", category: "Infra", rating: 4, reviews: 112, price: 20 },];/* end:skip-in-preview */// Get the DOM element with the ID 'example1' where the Handsontable will be renderedconst container = document.querySelector("#example1")!;
const starSvg = '<svg width="1em" height="1em" viewBox="0 0 24 24" fill="currentColor"><path d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"/></svg>';
const cellDefinition: Pick< CellProperties, "renderer" | "validator" | "editor"> = { renderer: rendererFactory(({ td, value }) => { td.innerHTML = `<div class="rating-cell">${Array.from( { length: 5 }, (_, index) => `<span class="rating-star ${index < value ? "active" : ""}">${starSvg}</span>`, ).join("")}</div>`; }), validator: (value, callback) => { value = parseInt(value); callback(value >= 0 && value <= 100); },
editor: editorFactory<{ input: HTMLDivElement }>({ shortcuts: [ { keys: [["1"], ["2"], ["3"], ["4"], ["5"]], callback: (editor, _event) => { editor.setValue((_event as KeyboardEvent).key); }, }, { keys: [["ArrowRight"]], callback: (editor, _event) => { if (parseInt(editor.value) < 5) { editor.setValue(parseInt(editor.value) + 1); } }, }, { keys: [["ArrowLeft"]], callback: (editor, _event) => { if (parseInt(editor.value) > 1) { editor.setValue(parseInt(editor.value) - 1); } }, }, ], init(editor) { editor.input = editor.hot.rootDocument.createElement( "DIV", ) as HTMLDivElement; editor.input.classList.add("rating-editor"); }, afterInit(editor) { editor.input.addEventListener("mouseover", (event) => { const star = (event.target as HTMLElement).closest( ".rating-star", ) as HTMLElement | null;
if ( star?.dataset.value && parseInt(editor.value) !== parseInt(star.dataset.value) ) { editor.setValue(star.dataset.value); } }); editor.input.addEventListener("mousedown", () => { editor.finishEditing(); }); }, render(editor) { editor.input.innerHTML = Array.from( { length: 5 }, (_, index) => `<span data-value="${index + 1}" class="rating-star ${ index < editor.value ? "active" : "" }${index + 1 === parseInt(editor.value) ? " current" : ""}">${starSvg}</span>`, ).join(""); }, }),};
// Define configuration options for the Handsontableconst hotOptions: Handsontable.GridSettings = { data, colHeaders: ["Product", "Category", "Rating", "Reviews", "Price"], autoRowSize: true, rowHeaders: true, height: "auto", width: "100%", autoWrapRow: true, headerClassName: "htLeft", columns: [ { data: "product", type: "text", width: 240 }, { data: "category", type: "text", width: 120 }, { data: "rating", width: 150, ...cellDefinition }, { data: "reviews", type: "numeric", width: 80 }, { data: "price", type: "numeric", width: 80 }, ], licenseKey: "non-commercial-and-evaluation",};
// Initialize the Handsontable instance with the specified configuration options// eslint-disable-next-line no-unused-varsconst hot = new Handsontable(container, hotOptions);.rating-cell { display: flex; align-items: center; margin: 3px 0 0 -1px;}
.rating-star { color: var(--ht-background-secondary-color, #e0e0e0 ); cursor: default; display: inline-flex; align-items: center;}
.rating-star.active { color: #facc15;}
.rating-editor { display: flex; align-items: center; width: 100%; height: 100%; box-sizing: border-box !important; border: none; border-radius: 0; box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px) var(--ht-cell-editor-border-color, #1a42e8), 0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0 var(--ht-cell-editor-shadow-color, transparent); background-color: var(--ht-cell-editor-background-color, #ffffff); padding: var(--ht-cell-vertical-padding, 4px) var(--ht-cell-horizontal-padding, 8px); font-family: inherit; font-size: inherit; line-height: inherit; cursor: pointer;}
.rating-editor .rating-star { cursor: pointer;}
.rating-editor .rating-star.current { color: var(--ht-accent-color, #1a42e8);}Overview
This guide shows how to create an interactive star rating cell using inline SVG stars. Perfect for product ratings, review scores, or any scenario where users need to provide a 1-5 star rating.
Difficulty: Beginner Time: ~15 minutes Libraries: None (pure HTML, SVG and JavaScript)
What You’ll Build
A cell that:
- Displays 5 SVG stars both when editing and viewing
- Shows filled stars (gold) and unfilled stars (gray)
- Uses Handsontable CSS tokens for theme-aware editor styling
- Supports mouse hover for preview
- Allows keyboard input (1-5 keys, arrow keys)
- Provides immediate visual feedback
- Works without any external libraries
Prerequisites
None! This uses only native HTML, SVG and JavaScript features.
Import Dependencies
import Handsontable from 'handsontable/base';import { registerAllModules } from 'handsontable/registry';import { editorFactory } from 'handsontable/editors';import { rendererFactory } from 'handsontable/renderers';registerAllModules();What we’re NOT importing:
- No icon libraries
- No UI component libraries
- No external SVG sprite sheets
- Handsontable only.
Define the Star SVG
Create an inline SVG string for the star shape. Using
fill="currentColor"allows CSS to control the star color.const starSvg ='<svg width="1em" height="1em" viewBox="0 0 24 24" fill="currentColor"><path d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"/></svg>';What’s happening:
width="1em" height="1em"- Stars scale with the font sizeviewBox="0 0 24 24"- Standard 24x24 coordinate spacefill="currentColor"- Inherits the CSScolorproperty, so active/inactive states are controlled via CSS- The
<path>draws a classic 5-pointed star shape
Why SVG instead of emoji?
- Consistent rendering across all browsers and operating systems
- Full control over color, size, and styling via CSS
- No platform-dependent emoji variations
- Crisp at any resolution
Add CSS Styling
Create a separate CSS file for the rating styles. This uses Handsontable CSS custom properties (tokens) so the editor automatically adapts to custom themes and dark mode.
.rating-cell {display: flex;align-items: center;margin: 3px 0 0 -1px;}.rating-star {color: var(--ht-background-secondary-color, #e0e0e0);cursor: default;display: inline-flex;align-items: center;}.rating-star.active {color: #facc15;}.rating-editor {display: flex;align-items: center;width: 100%;height: 100%;box-sizing: border-box !important;border: none;border-radius: 0;box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)var(--ht-cell-editor-border-color, #1a42e8),0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0var(--ht-cell-editor-shadow-color, transparent);background-color: var(--ht-cell-editor-background-color, #ffffff);padding: var(--ht-cell-vertical-padding, 4px)var(--ht-cell-horizontal-padding, 8px);font-family: inherit;font-size: inherit;line-height: inherit;cursor: pointer;}.rating-editor .rating-star {cursor: pointer;}.rating-editor .rating-star.current {color: var(--ht-accent-color, #1a42e8);}Cell container:
.rating-cellwraps the stars in the renderer withdisplay: flexto match the editor layoutmargin: 3px 0 0 -1px- Fine-tunes alignment between renderer and editor to prevent visual jump
Star colors:
var(--ht-background-secondary-color, #e0e0e0)- Inactive/unfilled stars (adapts to theme)#facc15(gold) - Active/filled stars- Colors are applied via the CSS
colorproperty, which the SVG inherits throughfill="currentColor"
Current star indicator:
.rating-editor .rating-star.currenthighlights the last active star (the one matching the rating value) using--ht-accent-color- Makes it clear which star is selected while editing — the current star turns blue (accent color) instead of gold
Handsontable tokens used:
--ht-background-secondary-color- Inactive star color (adapts to theme)--ht-accent-color- Current star highlight in editor (blue)--ht-cell-editor-border-color/--ht-cell-editor-border-width- blue border matching native editors--ht-cell-editor-background-color- editor background--ht-cell-editor-shadow-blur-radius/--ht-cell-editor-shadow-color- editor shadow--ht-cell-vertical-padding/--ht-cell-horizontal-padding- consistent cell padding matching the renderer
Create the Renderer
The renderer displays 5 SVG stars wrapped in a flex container using CSS classes for color control.
renderer: rendererFactory(({ td, value }) => {td.innerHTML = `<div class="rating-cell">${Array.from({ length: 5 },(_, index) =>`<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`).join('')}</div>`;})What’s happening:
- Stars are wrapped in a
<div class="rating-cell">flex container to match the editor’s flex layout Array.from({ length: 5 })- Creates an array with 5 elements (indices 0-4)index < value- Stars up to the rating value get theactiveclass (gold color)index >= value- Stars beyond the rating stay gray via CSS- Each span contains the inline SVG star
join('')- Concatenates all star spans into a single string
- Stars are wrapped in a
Create the Validator
Ensure values are within the valid range.
validator: (value, callback) => {value = parseInt(value);callback(value >= 0 && value <= 100);}What’s happening:
- Convert value to integer (keyboard input returns strings)
- Validate the value is within the acceptable range
- Call
callback(true)for valid,callback(false)for invalid
Editor - Initialize (
init)Create the container div for the star rating editor.
init(editor) {editor.input = editor.hot.rootDocument.createElement('DIV') as HTMLDivElement;editor.input.classList.add('rating-editor');}What’s happening:
- Create a
divcontainer for the star buttons - Add the
rating-editorCSS class (all styling is in the CSS file) - This container will hold the 5 SVG star elements
Key styling (from CSS):
display: flex; align-items: center- Stars aligned verticallybox-shadowwith--ht-cell-editor-border-color- Blue border matching native editorspaddingwith cell padding tokens - Matches renderer to prevent visual jumpfont-family/font-size/line-height: inherit- Consistent sizing with the cell
- Create a
Editor - After Init Hook (
afterInit)Set up mouse events for hover preview and click selection.
afterInit(editor) {editor.input.addEventListener('mouseover', (event) => {const star = (event.target as HTMLElement).closest('.rating-star') as HTMLElement | null;if (star?.dataset.value &&parseInt(editor.value) !== parseInt(star.dataset.value)) {editor.setValue(star.dataset.value);}});editor.input.addEventListener('mousedown', () => {editor.finishEditing();});}What’s happening:
Mouseover Event:
- User hovers over a star (or its SVG child element)
- Use
closest('.rating-star')to find the parent span — this is important because the hover target may be the SVG<path>element inside the span - Get the hover rating from the span’s
dataset.value - If different from current value, update it
- This creates a “preview” effect as user hovers
Mousedown Event:
- User clicks (mousedown) anywhere in the editor
- Finish editing immediately
- Value is saved to the cell
Why
closest()instead of checkingevent.targetdirectly?- With inline SVGs, the actual hover/click target is often the
<svg>or<path>element, not the parent<span> closest('.rating-star')walks up the DOM tree to find the span with thedata-valueattribute- This ensures reliable star detection regardless of which SVG child element the user interacts with
Editor - Render Function (
render)Generate the HTML for the 5 star buttons based on current rating.
render(editor) {editor.input.innerHTML = Array.from({ length: 5 },(_, index) =>`<span data-value="${index + 1}" class="rating-star ${index < editor.value ? 'active' : ''}${index + 1 === parseInt(editor.value) ? ' current' : ''}">${starSvg}</span>`).join('');}What’s happening:
- Create 5 star spans (indices 0-4, values 1-5)
- Each span has
data-valueattribute with rating (1-5) - Stars use the
rating-starclass for base styling (gray color) - Active stars get the
activeclass (gold color) - The star matching the current value gets the
currentclass (accent color) — this highlights the selected rating in the editor - Each span contains the inline SVG star
- Join all spans into a single HTML string
Dynamic rendering:
- Updates whenever
editor.setValue()is called - Automatically called by
editorFactorywhen value changes - Provides live preview as user interacts
Editor - Keyboard Shortcuts
Add keyboard support for rating selection.
shortcuts: [{keys: [['1'], ['2'], ['3'], ['4'], ['5']],callback: (editor, _event) => {editor.setValue((_event as KeyboardEvent).key);}},{keys: [['ArrowRight']],callback: (editor, _event) => {if (parseInt(editor.value) < 5) {editor.setValue(parseInt(editor.value) + 1);}}},{keys: [['ArrowLeft']],callback: (editor, _event) => {if (parseInt(editor.value) > 1) {editor.setValue(parseInt(editor.value) - 1);}}}]What’s happening:
Number Keys (1-5):
- Press 1-5 to set rating directly
- Fastest way to select a specific rating
- Gets key value from keyboard event
Arrow Keys:
- ArrowRight: Increase rating (max 5)
- ArrowLeft: Decrease rating (min 1)
- Bounded within valid range
- Smooth incremental adjustment
Keyboard navigation benefits:
- Fast selection without mouse
- Accessible for keyboard-only users
- Number keys for direct selection, arrows for adjustment
Complete Cell Definition
const starSvg ='<svg width="1em" height="1em" viewBox="0 0 24 24" fill="currentColor"><path d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"/></svg>';const cellDefinition = {renderer: rendererFactory(({ td, value }) => {td.innerHTML = `<div class="rating-cell">${Array.from({ length: 5 },(_, index) =>`<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`).join('')}</div>`;}),validator: (value, callback) => {value = parseInt(value);callback(value >= 0 && value <= 100);},editor: editorFactory<{ input: HTMLDivElement }>({shortcuts: [{keys: [['1'], ['2'], ['3'], ['4'], ['5']],callback: (editor, _event) => {editor.setValue((_event as KeyboardEvent).key);},},{keys: [['ArrowRight']],callback: (editor, _event) => {if (parseInt(editor.value) < 5) {editor.setValue(parseInt(editor.value) + 1);}},},{keys: [['ArrowLeft']],callback: (editor, _event) => {if (parseInt(editor.value) > 1) {editor.setValue(parseInt(editor.value) - 1);}},},],init(editor) {editor.input = editor.hot.rootDocument.createElement('DIV') as HTMLDivElement;editor.input.classList.add('rating-editor');},afterInit(editor) {editor.input.addEventListener('mouseover', (event) => {const star = (event.target as HTMLElement).closest('.rating-star') as HTMLElement | null;if (star?.dataset.value &&parseInt(editor.value) !== parseInt(star.dataset.value)) {editor.setValue(star.dataset.value);}});editor.input.addEventListener('mousedown', () => {editor.finishEditing();});},render(editor) {editor.input.innerHTML = Array.from({ length: 5 },(_, index) =>`<span data-value="${index + 1}" class="rating-star ${index < editor.value ? 'active' : ''}${index + 1 === parseInt(editor.value) ? ' current' : ''}">${starSvg}</span>`).join('');},}),};What’s happening:
- starSvg: Inline SVG star with
fill="currentColor"for CSS color control - renderer: Displays 5 SVG stars wrapped in a
.rating-cellflex container with CSS class-based coloring (gold/gray) - validator: Ensures rating is within valid range
- editor: Uses
editorFactoryhelper with:- Keyboard shortcuts for 1-5 keys and arrow keys
- Container initialization with
rating-editorCSS class - Mouse events using
closest()for reliable SVG hover detection - Render function with
currentclass to highlight the selected star using accent color
- starSvg: Inline SVG star with
Use in Handsontable
const container = document.querySelector('#example1')!;const hotOptions: Handsontable.GridSettings = {data,colHeaders: ['Product', 'Category', 'Rating', 'Reviews', 'Price'],autoRowSize: true,rowHeaders: true,height: 'auto',width: '100%',autoWrapRow: true,headerClassName: 'htLeft',columns: [{ data: 'product', type: 'text', width: 240 },{ data: 'category', type: 'text', width: 120 },{ data: 'rating', width: 150, ...cellDefinition },{ data: 'reviews', type: 'numeric', width: 80 },{ data: 'price', type: 'numeric', width: 80 },],licenseKey: 'non-commercial-and-evaluation',};const hot = new Handsontable(container, hotOptions);Key configuration:
...cellDefinition- Spreads the renderer, validator, and editor onto the Rating columnheaderClassName: 'htLeft'- Left-aligns all column headerswidth: '100%'- Table fills the container width
How It Works - Complete Flow
- Initial Render: Cell displays 5 SVG stars — gold for filled, gray for unfilled
- User Double-Clicks or Enter: Editor opens over cell showing interactive stars with Handsontable blue border
- Current Star Indicator: The last active star turns blue (accent color) to clearly show the selected rating
- Mouse Hover: User hovers over stars → preview rating updates in real-time (detected via
closest()) - Click Selection: User clicks → rating selected and editor closes
- Keyboard Input: User presses 1-5 keys → rating set directly
- Arrow Navigation: User presses ArrowLeft/ArrowRight → rating increments/decrements
- Validation: Validator checks the value is valid
- Save: Valid value saved to cell
- Editor Closes: Cell shows updated star rating
Enhancements
Show Numeric Value
Display the numeric rating alongside stars:
renderer: rendererFactory(({ td, value }) => {const stars = Array.from({ length: 5 }, (_, index) =>`<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`).join('');td.innerHTML = `<div style="display: flex; align-items: center; gap: 8px;"><span>${stars}</span><span style="font-weight: bold; color: #666;">${value}/5</span></div>`;})Custom Star Count
Configurable number of stars per column:
renderer: rendererFactory(({ td, value, cellProperties }) => {const maxStars = cellProperties.maxStars || 5;td.innerHTML = Array.from({ length: maxStars }, (_, index) =>`<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`).join('');})// Usagecolumns: [{data: 'rating',...cellDefinition,maxStars: 10 // 10-star rating}]Text Labels
Add text labels like “Excellent”, “Good”, etc.:
renderer: rendererFactory(({ td, value }) => {const labels = ['', 'Poor', 'Fair', 'Good', 'Very Good', 'Excellent'];const label = labels[value] || '';const stars = Array.from({ length: 5 }, (_, index) =>`<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`).join('');td.innerHTML = `<div style="display: flex; align-items: center; gap: 8px;"><span>${stars}</span><span style="font-size: 0.9em; color: #666;">${label}</span></div>`;})Custom Star Colors
Change colors by overriding CSS for specific columns:
/* Red/green rating */.custom-rating .rating-star {color: #e5e7eb;}.custom-rating .rating-star.active {color: #22c55e;}
Accessibility
Keyboard navigation:
- Number keys (1-5): Direct rating selection
- ArrowRight: Increase rating (max 5)
- ArrowLeft: Decrease rating (min 1)
- Enter: Confirm selection and finish editing
- Escape: Cancel editing
What you learned
You built an SVG star rating cell using editorFactory and rendererFactory. You used Handsontable CSS tokens for theme-aware styling, closest() for reliable hover detection on inline SVG elements, and keyboard shortcuts for direct number-key and arrow-key selection.
Next steps
- Star Rating (React) - The same concept using React’s
EditorComponentand a local star rating component. - Star Rating Editor (Angular) - The Angular version using
HotCellEditorAdvancedComponent. - Feedback - Another no-library custom editor using
editorFactoryand CSS tokens.

Skip to content

This tutorial shows you how to build a star rating cell in React using Handsontable’s EditorComponent, a custom renderer, and a local React component for the stars.

JavaScript
import { HotTable, HotColumn, EditorComponent } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import './example1.css';
registerAllModules();
function StarRating({ name, value, editing = true, onStarHover, onStarClick }) {
return (
<div className="star-rating" aria-label={`Rating: ${value} out of 5`}>
{[1, 2, 3, 4, 5].map((star) => (
<span
key={`${name}-${star}`}
className={star <= value ? 'star filled' : 'star'}
onMouseEnter={editing ? () => onStarHover?.(star) : undefined}
onClick={editing ? () => onStarClick?.(star) : undefined}
>
</span>
))}
</div>
);
}
/* start:skip-in-preview */
export const data = [
{ product: 'Dashboard Pro', category: 'Analytics', rating: 5, reviews: 342, price: 49 },
{ product: 'Form Builder', category: 'Tools', rating: 4, reviews: 218, price: 29 },
{ product: 'Chart Engine', category: 'Analytics', rating: 3, reviews: 156, price: 39 },
{ product: 'Auth Module', category: 'Security', rating: 5, reviews: 89, price: 19 },
{ product: 'File Manager', category: 'Storage', rating: 2, reviews: 64, price: 15 },
{ product: 'Email Service', category: 'Communication', rating: 4, reviews: 275, price: 25 },
{ product: 'Search Index', category: 'Tools', rating: 1, reviews: 31, price: 35 },
{ product: 'Cache Layer', category: 'Infra', rating: 4, reviews: 112, price: 20 },
];
/* end:skip-in-preview */
const RatingCellRenderer = ({ value }) => (
<div className="rating-cell">
<StarRating
name="rating-cell"
value={Number(value) || 0}
editing={false}
/>
</div>
);
const ratingValidator = (value, callback) => {
value = parseInt(value);
callback(value >= 0 && value <= 100);
};
export const RatingEditor = () => {
return (
<EditorComponent>
{({ value, setValue, finishEditing }) => (
<div className="rating-editor">
<StarRating
name="rating"
value={Number(value) || 0}
onStarHover={(nextValue) => setValue(nextValue)}
onStarClick={(nextValue) => {
setValue(nextValue);
finishEditing();
}}
/>
</div>
)}
</EditorComponent>
);
};
const ExampleComponent = () => {
return (
<HotTable
data={data}
colHeaders={['Product', 'Category', 'Rating', 'Reviews', 'Price']}
autoRowSize={true}
rowHeaders={true}
height="auto"
width="100%"
autoWrapRow={true}
headerClassName="htLeft"
licenseKey="non-commercial-and-evaluation"
>
<HotColumn data="product" type="text" width={200} />
<HotColumn data="category" type="text" width={120} />
<HotColumn
data="rating"
width={150}
editor={RatingEditor}
renderer={RatingCellRenderer}
validator={ratingValidator}
/>
<HotColumn data="reviews" type="numeric" width={80} />
<HotColumn data="price" type="numeric" width={80} />
</HotTable>
);
};
export default ExampleComponent;
TypeScript
import { HotTable, HotColumn, EditorComponent } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import './example1.css';
registerAllModules();
interface StarRatingProps {
name: string;
value: number;
editing?: boolean;
onStarHover?: (value: number) => void;
onStarClick?: (value: number) => void;
}
function StarRating({ name, value, editing = true, onStarHover, onStarClick }: StarRatingProps) {
return (
<div className="star-rating" aria-label={`Rating: ${value} out of 5`}>
{[1, 2, 3, 4, 5].map((star) => (
<span
key={`${name}-${star}`}
className={star <= value ? 'star filled' : 'star'}
onMouseEnter={editing ? () => onStarHover?.(star) : undefined}
onClick={editing ? () => onStarClick?.(star) : undefined}
>
</span>
))}
</div>
);
}
/* start:skip-in-preview */
export const data = [
{ product: "Dashboard Pro", category: "Analytics", rating: 5, reviews: 342, price: 49 },
{ product: "Form Builder", category: "Tools", rating: 4, reviews: 218, price: 29 },
{ product: "Chart Engine", category: "Analytics", rating: 3, reviews: 156, price: 39 },
{ product: "Auth Module", category: "Security", rating: 5, reviews: 89, price: 19 },
{ product: "File Manager", category: "Storage", rating: 2, reviews: 64, price: 15 },
{ product: "Email Service", category: "Communication", rating: 4, reviews: 275, price: 25 },
{ product: "Search Index", category: "Tools", rating: 1, reviews: 31, price: 35 },
{ product: "Cache Layer", category: "Infra", rating: 4, reviews: 112, price: 20 },
];
/* end:skip-in-preview */
const RatingCellRenderer = ({ value }: { value: unknown }) => (
<div className="rating-cell">
<StarRating
name="rating-cell"
value={Number(value) || 0}
editing={false}
/>
</div>
);
const ratingValidator = (value: string | number, callback: (valid: boolean) => void) => {
const parsed = parseInt(String(value));
callback(parsed >= 0 && parsed <= 100);
};
export const RatingEditor = () => {
return (
<EditorComponent<number>>
{({ value, setValue, finishEditing }) => (
<div className="rating-editor">
<StarRating
name="rating"
value={Number(value) || 0}
onStarHover={(nextValue) => setValue(nextValue)}
onStarClick={(nextValue) => {
setValue(nextValue);
finishEditing();
}}
/>
</div>
)}
</EditorComponent>
);
};
const ExampleComponent = () => {
return (
<HotTable
data={data}
colHeaders={["Product", "Category", "Rating", "Reviews", "Price"]}
autoRowSize={true}
rowHeaders={true}
height="auto"
width="100%"
autoWrapRow={true}
headerClassName="htLeft"
licenseKey="non-commercial-and-evaluation"
>
<HotColumn data="product" type="text" width={240} />
<HotColumn data="category" type="text" width={120} />
<HotColumn
data="rating"
width={150}
editor={RatingEditor}
renderer={RatingCellRenderer}
validator={ratingValidator}
/>
<HotColumn data="reviews" type="numeric" width={80} />
<HotColumn data="price" type="numeric" width={80} />
</HotTable>
);
};
export default ExampleComponent;
CSS
.star-rating {
display: inline-flex;
gap: 1px;
}
.star-rating .star {
font-size: 18px;
color: #d3d3d3;
line-height: 1;
cursor: default;
user-select: none;
transition: color 0.1s;
}
.rating-editor .star-rating .star {
cursor: pointer;
}
.star-rating .star.filled {
color: #ffb400;
}
.rating-cell {
display: flex;
align-items: center;
margin: 3px 0 0 -1px;
}
.rating-editor {
display: flex;
align-items: center;
height: 100%;
box-sizing: border-box !important;
border: none;
border-radius: 0;
box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
var(--ht-cell-editor-border-color, #1a42e8),
0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
var(--ht-cell-editor-shadow-color, transparent);
background-color: var(--ht-cell-editor-background-color, #ffffff);
padding: var(--ht-cell-vertical-padding, 4px)
var(--ht-cell-horizontal-padding, 8px);
font-family: var(--ht-font-family, inherit);
font-size: var(--ht-font-size, 14px);
line-height: var(--ht-line-height, 1.5);
}

Overview

This guide shows how to create a star rating editor cell using React’s EditorComponent. Use this pattern for product reviews, feedback forms, or any scenario where users select a numeric rating, such as 1-5 stars.

Difficulty: Beginner Time: ~15 minutes Libraries: No external rating library.

What You’ll Build

A cell that:

  • Displays interactive star rating when editing
  • Shows stars in view mode via a custom React renderer
  • Supports hover preview before selection
  • Stores values as numbers (1-5)
  • Validates rating range, such as 0-100
  • Provides click-to-select functionality
  • Works with React’s component-based architecture

Prerequisites

Terminal window
npm install handsontable @handsontable/react-wrapper

What you need:

  • React 16.8+ (hooks support)
  • @handsontable/react-wrapper package
  • Basic React knowledge (hooks, JSX)
  1. Import Dependencies

    import { HotTable, HotColumn, EditorComponent } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    registerAllModules();

    What we’re importing:

    • EditorComponent - React component for creating custom editors
    • HotTable and HotColumn - React wrapper components
    • registerAllModules() - Registers Handsontable modules (required when using the wrapper)
  2. Create the Star Rating Component

    Create a local component that renders five stars and reports hover and click events.

    interface StarRatingProps {
    name: string;
    value: number;
    editing?: boolean;
    onStarHover?: (value: number) => void;
    onStarClick?: (value: number) => void;
    }
    function StarRating({ name, value, editing = true, onStarHover, onStarClick }: StarRatingProps) {
    return (
    <div className="star-rating" aria-label={`Rating: ${value} out of 5`}>
    {[1, 2, 3, 4, 5].map((star) => (
    <span
    key={`${name}-${star}`}
    className={star <= value ? 'star filled' : 'star'}
    onMouseEnter={editing ? () => onStarHover?.(star) : undefined}
    onClick={editing ? () => onStarClick?.(star) : undefined}
    >
    </span>
    ))}
    </div>
    );
    }

    What’s happening:

    • The name prop creates stable keys for each star.
    • The editing prop disables hover and click handlers in view mode.
    • onStarHover previews the value before the user commits it.
    • onStarClick commits the selected value.
  3. Create the Editor Component

    Create a React component that uses EditorComponent with the render prop pattern.

    export const RatingEditor = () => {
    return (
    <EditorComponent<number>>
    {({ value, setValue, finishEditing }) => (
    <div className="rating-editor">
    <StarRating
    name="rating"
    value={Number(value) || 0}
    onStarHover={(nextValue) => setValue(nextValue)}
    onStarClick={(nextValue) => {
    setValue(nextValue);
    finishEditing();
    }}
    />
    </div>
    )}
    </EditorComponent>
    );
    };

    What’s happening:

    1. EditorComponent wraps your editor UI; the children prop is a function that receives editor state.
    2. value - Current cell value (numeric rating)
    3. setValue - Function to update the value
    4. finishEditing - Function to save and close the editor
    5. StarRating - Renders the local star picker
    6. onStarHover - Updates preview as the user hovers over stars
    7. onStarClick - Saves the selected rating and closes the editor
    8. The rating-editor div is inside the render prop so styling applies to the visible editor area.

    Key concepts:

    • Render prop pattern: EditorComponent uses a function as children
    • Hover preview: onStarHover lets users preview before committing
    • Click to confirm: onStarClick saves and closes the editor
  4. Add a Custom Renderer for View Mode

    Use a React component as the cell renderer so stars are shown when not editing.

    const RatingCellRenderer = ({ value }: { value: unknown }) => (
    <div className="rating-cell">
    <StarRating
    name="rating-cell"
    value={Number(value) || 0}
    editing={false}
    />
    </div>
    );

    What’s happening:

    • The renderer receives value and displays it with StarRating
    • editing={false} keeps the stars non-interactive in view mode
    • Use a unique name (for example, "rating-cell") to keep stable React keys for the renderer
  5. Add a Validator (Optional)

    Validate that the rating is within an allowed range, such as 0-100:

    const ratingValidator = (value: string | number, callback: (valid: boolean) => void) => {
    const parsed = parseInt(String(value));
    callback(parsed >= 0 && parsed <= 100);
    };

    For a strict 1-5 star scale, use parsed >= 1 && parsed <= 5 instead.

  6. Add Styling

    Style the cell and editor so the star rating fits and matches the grid.

    .star-rating {
    display: inline-flex;
    gap: 1px;
    }
    .star-rating .star {
    font-size: 18px;
    color: #d3d3d3;
    line-height: 1;
    cursor: default;
    user-select: none;
    transition: color 0.1s;
    }
    .rating-editor .star-rating .star {
    cursor: pointer;
    }
    .star-rating .star.filled {
    color: #ffb400;
    }
    .rating-cell {
    display: flex;
    align-items: center;
    margin: 3px 0 0 -1px;
    }
    .rating-editor {
    display: flex;
    align-items: center;
    height: 100%;
    box-sizing: border-box !important;
    border: none;
    border-radius: 0;
    box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
    var(--ht-cell-editor-border-color, #1a42e8),
    0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
    var(--ht-cell-editor-shadow-color, transparent);
    background-color: var(--ht-cell-editor-background-color, #ffffff);
    padding: var(--ht-cell-vertical-padding, 4px)
    var(--ht-cell-horizontal-padding, 8px);
    font-family: var(--ht-font-family, inherit);
    font-size: var(--ht-font-size, 14px);
    line-height: var(--ht-line-height, 1.5);
    }

    What’s happening:

    • .star-rating lays out the local star component
    • .star-rating .star.filled colors the selected stars
    • .rating-cell aligns the stars in the cell when not editing
    • .rating-editor uses Handsontable CSS variables for focus border, background, and padding so the editor matches the grid theme
  7. Prepare Sample Data

    Use data with a rating property (and any other columns you need). Example for a product table:

    export const data = [
    { product: "Dashboard Pro", category: "Analytics", rating: 5, reviews: 342, price: 49 },
    { product: "Form Builder", category: "Tools", rating: 4, reviews: 218, price: 29 },
    { product: "Chart Engine", category: "Analytics", rating: 3, reviews: 156, price: 39 },
    { product: "Auth Module", category: "Security", rating: 5, reviews: 89, price: 19 },
    { product: "File Manager", category: "Storage", rating: 2, reviews: 64, price: 15 },
    { product: "Email Service", category: "Communication", rating: 4, reviews: 275, price: 25 },
    { product: "Search Index", category: "Tools", rating: 1, reviews: 31, price: 35 },
    { product: "Cache Layer", category: "Infra", rating: 4, reviews: 112, price: 20 },
    ];

    What’s happening:

    • Each row has product, category, rating, reviews, and price
    • The rating column uses the star editor and renderer; other columns can be text or numeric
  8. Use in Handsontable

    Wire the editor, renderer, and validator to the rating column:

    const ExampleComponent = () => {
    return (
    <HotTable
    data={data}
    colHeaders={["Product", "Category", "Rating", "Reviews", "Price"]}
    autoRowSize={true}
    rowHeaders={true}
    height="auto"
    width="100%"
    autoWrapRow={true}
    headerClassName="htLeft"
    licenseKey="non-commercial-and-evaluation"
    >
    <HotColumn data="product" type="text" width={240} />
    <HotColumn data="category" type="text" width={120} />
    <HotColumn
    data="rating"
    width={150}
    editor={RatingEditor}
    renderer={RatingCellRenderer}
    validator={ratingValidator}
    />
    <HotColumn data="reviews" type="numeric" width={80} />
    <HotColumn data="price" type="numeric" width={80} />
    </HotTable>
    );
    };

    What’s happening:

    • editor={RatingEditor} - Star rating editor when the cell is active
    • renderer={RatingCellRenderer} - Shows stars in view mode
    • validator={ratingValidator} - Ensures rating is within the allowed range, such as 0-100
    • data="rating" - Binds to the rating property in each row

    Key features:

    • Stars in both view and edit mode
    • Values stored as numbers (1-5)
    • Validation and type-safe setup with TypeScript

How It Works - Complete Flow

  1. Initial Render: RatingCellRenderer displays stars for the current rating, such as 3 filled stars.
  2. User Double-Clicks or Enter: Editor opens.
  3. Editor Opens: EditorComponent shows the star picker in the cell.
  4. Star Rating Display: StarRating shows the current value; empty stars show the remaining scale.
  5. User Interaction:
    • Hover over stars → onStarHover updates preview via setValue
    • Click a star → onStarClick saves value and calls finishEditing()
  6. Validation: ratingValidator runs, such as checking that the value is 0-100.
  7. Save: Numeric value is saved to the cell.
  8. Editor Closes: RatingCellRenderer shows the updated stars in view mode.

Enhancements

  1. Custom Star Count

    Change the number of stars, such as a 10-point scale:

    interface StarRatingProps {
    name: string;
    value: number;
    starCount?: number;
    editing?: boolean;
    onStarHover?: (value: number) => void;
    onStarClick?: (value: number) => void;
    }
    function StarRating({ name, value, starCount = 5, editing = true, onStarHover, onStarClick }: StarRatingProps) {
    const stars = Array.from({ length: starCount }, (_, index) => index + 1);
    return (
    <div className="star-rating" aria-label={`Rating: ${value} out of ${starCount}`}>
    {stars.map((star) => (
    <span
    key={`${name}-${star}`}
    className={star <= value ? 'star filled' : 'star'}
    onMouseEnter={editing ? () => onStarHover?.(star) : undefined}
    onClick={editing ? () => onStarClick?.(star) : undefined}
    >
    </span>
    ))}
    </div>
    );
    }
  2. Custom Star Colors

    Customize the appearance:

    .star-rating .star {
    color: #e0e0e0;
    }
    .star-rating .star.filled {
    color: #ffd700;
    }
  3. Alternative: HTML-Based Renderer

    The main example uses a React component (RatingCellRenderer) for view mode. If you prefer a non-React renderer, you can use rendererFactory:

    import { rendererFactory } from 'handsontable/renderers';
    const starRenderer = rendererFactory(({ td, value }) => {
    const rating = Number(value) || 0;
    const stars = '★'.repeat(rating) + '☆'.repeat(5 - rating);
    td.innerHTML = `
    <div style="
    font-size: 1.2em;
    color: #ffb400;
    letter-spacing: 2px;
    ">${stars}</div>
    `;
    });
    // Use in HotColumn
    <HotColumn
    data="rating"
    width={150}
    editor={RatingEditor}
    renderer={starRenderer}
    />
  4. Read Config from Cell Properties (Advanced)

    Use onPrepare for per-column configuration, such as star count:

    const RatingEditor = () => {
    const [starCount, setStarCount] = useState(5);
    const onPrepare = (_row, _column, _prop, _TD, _originalValue, cellProperties) => {
    if (cellProperties.starCount != null) {
    setStarCount(cellProperties.starCount);
    }
    };
    return (
    <div className="rating-editor">
    <EditorComponent<number> onPrepare={onPrepare}>
    {({ value, setValue, finishEditing }) => (
    <StarRating
    name="rating"
    starCount={starCount}
    value={Number(value) || 0}
    onStarHover={(nextValue) => setValue(nextValue)}
    onStarClick={(nextValue) => {
    setValue(nextValue);
    finishEditing();
    }}
    />
    )}
    </EditorComponent>
    </div>
    );
    };
    // Use with different star counts per column
    <HotColumn editor={RatingEditor} starCount={5} data="rating" title="Rating (1-5)" />
    <HotColumn editor={RatingEditor} starCount={10} data="score" title="Score (1-10)" />
  5. Handle Empty Values

    Ensure the component handles undefined or null:

    value={Number(value) || 0}

    This displays empty stars when the cell has no value.

Accessibility

The local StarRating component sets aria-label on the rating container. To add keyboard support, render each star as a button:

<button
type="button"
className={star <= value ? 'star filled' : 'star'}
onMouseEnter={editing ? () => onStarHover?.(star) : undefined}
onClick={editing ? () => onStarClick?.(star) : undefined}
aria-label={`Set rating to ${star}`}
>
</button>

Keyboard navigation:

  • Tab: Navigate to editor
  • Arrow keys: Navigate between stars after you add key handlers
  • Enter/Space: Select star
  • Escape: Cancel editing

Performance Considerations

Why This Is Fast

  1. No external rating package: The star UI uses a small local component.
  2. React Virtual DOM: Updates happen only when the value changes.
  3. Focused callbacks: onStarHover and onStarClick each do one thing.
  4. No unnecessary re-renders: The editor unmounts when closed.

TypeScript Support

EditorComponent is fully typed. Specify the value type for numeric ratings:

<EditorComponent<number>>
{({ value, setValue, finishEditing }) => {
// TypeScript knows value is number | undefined
// TypeScript knows setValue accepts number
return (
<StarRating
name="rating"
value={Number(value) || 0}
onStarHover={(nextValue) => setValue(nextValue)}
onStarClick={(nextValue) => {
setValue(nextValue);
finishEditing();
}}
/>
);
}}
</EditorComponent>

Best Practices

  1. Coerce value to number - Use Number(value) || 0 since cell values may be strings.
  2. Provide name prop - Use different names for editor and renderer, such as "rating" and "rating-cell", to keep stable React keys.
  3. Call finishEditing() on click - Star click confirms the selection and closes the editor.
  4. Use onStarHover for preview - Improves UX by showing the selection before commit.
  5. Use a custom renderer - RatingCellRenderer with editing={false} shows stars in view mode and keeps the UI consistent.
  6. Add a validator - Use ratingValidator to restrict values, such as 0-100 or 1-5, and give immediate feedback.

What you learned

You created a local StarRating component and integrated it as a Handsontable cell editor in React. You used EditorComponent with the render prop pattern to manage hover preview and click-to-confirm selection, and a React component renderer to display stars in view mode.

Next steps

Skip to content

This tutorial shows you how to build an interactive SVG star rating cell using editorFactory and rendererFactory, with hover preview and keyboard shortcuts - no external libraries required.

TypeScript
/* file: app.component.ts */
import { Component, ChangeDetectorRef, ChangeDetectionStrategy, inject } from '@angular/core';
import { DomSanitizer, SafeHtml } from '@angular/platform-browser';
import {
GridSettings,
HotCellEditorAdvancedComponent,
HotCellRendererAdvancedComponent,
KeyboardShortcutConfig,
HotTableModule
} from '@handsontable/angular-wrapper';
/* start:skip-in-preview */
const starSvg =
'<svg width="1em" height="1em" viewBox="0 0 24 24" fill="currentColor"><path d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"/></svg>';
const inputData = [
{ product: 'Dashboard Pro', category: 'Analytics', rating: 5, reviews: 342, price: 49 },
{ product: 'Form Builder', category: 'Tools', rating: 4, reviews: 218, price: 29 },
{ product: 'Chart Engine', category: 'Analytics', rating: 3, reviews: 156, price: 39 },
{ product: 'Auth Module', category: 'Security', rating: 5, reviews: 89, price: 19 },
{ product: 'File Manager', category: 'Storage', rating: 2, reviews: 64, price: 15 },
{ product: 'Email Service', category: 'Communication', rating: 4, reviews: 275, price: 25 },
{ product: 'Search Index', category: 'Tools', rating: 1, reviews: 31, price: 35 },
{ product: 'Cache Layer', category: 'Infra', rating: 4, reviews: 112, price: 20 },
];
/* end:skip-in-preview */
@Component({
standalone: true,
selector: 'example1-star-renderer',
changeDetection: ChangeDetectionStrategy.OnPush,
template: `
<div class="rating-cell">
@for (star of stars; track $index) {
<span class="rating-star" [class.active]="$index < value" [innerHTML]="starSvgMarkup"></span>
}
</div>`,
})
export class StarRendererComponent extends HotCellRendererAdvancedComponent<number> {
readonly stars = Array(5);
readonly starSvgMarkup: SafeHtml = inject(DomSanitizer).bypassSecurityTrustHtml(starSvg);
}
@Component({
standalone: true,
selector: 'example1-star-editor',
template: `
<div class="rating-editor" (mouseover)="onMouseOver($event)" (mousedown)="onMouseDown()">
@for (star of stars; track $index) {
<span
[attr.data-value]="$index + 1"
class="rating-star"
[class.active]="$index < getValue()"
[class.current]="isCurrentStar($index)"
[innerHTML]="starSvgMarkup"
></span>
}
</div>
`,
})
export class StarEditorComponent extends HotCellEditorAdvancedComponent<number> {
readonly stars = Array(5);
readonly starSvgMarkup: SafeHtml = inject(DomSanitizer).bypassSecurityTrustHtml(starSvg);
isCurrentStar(index: number): boolean {
return (index + 1) === parseInt(this.getValue()?.toString() ?? '0', 10);
}
private readonly cdr = inject(ChangeDetectorRef);
override shortcuts?: KeyboardShortcutConfig[] = [
{
keys: [['1'], ['2'], ['3'], ['4'], ['5']],
callback: (_editor, event) => {
this.setValue(parseInt((event as KeyboardEvent).key, 10));
this.cdr.detectChanges();
},
},
{
keys: [['ArrowRight']],
callback: (_editor, _event) => {
if (parseInt(this.getValue()?.toString() ?? '0') < 5) {
this.setValue(parseInt(this.getValue()?.toString() ?? '0') + 1);
this.cdr.detectChanges();
}
},
},
{
keys: [['ArrowLeft']],
callback: (_editor, _event) => {
if (parseInt(this.getValue()?.toString() ?? '0') > 1) {
this.setValue(parseInt(this.getValue()?.toString() ?? '0') - 1);
this.cdr.detectChanges();
}
},
},
];
onMouseOver(event: MouseEvent): void {
const star = (event.target as HTMLElement).closest('.rating-star') as HTMLElement | null;
if (
star?.dataset['value'] &&
parseInt(this.getValue()?.toString() ?? '0') !== parseInt(star.dataset['value'], 10)
) {
this.setValue(parseInt(star.dataset['value'], 10));
this.cdr.detectChanges();
}
}
onMouseDown(): void {
this.finishEdit.emit();
}
}
@Component({
standalone: true,
imports: [HotTableModule],
selector: 'example1-rating',
template: `<div><hot-table [data]="data" [settings]="gridSettings"></hot-table></div>`,
})
export class AppComponent {
readonly data = inputData;
readonly gridSettings: GridSettings = {
autoRowSize: true,
rowHeaders: true,
autoWrapRow: true,
height: 'auto',
width: '100%',
headerClassName: 'htLeft',
colHeaders: ['Product', 'Category', 'Rating', 'Reviews', 'Price'],
columns: [
{ data: 'product', type: 'text', width: 240 },
{ data: 'category', type: 'text', width: 120 },
{
data: 'rating',
width: 150,
renderer: StarRendererComponent,
editor: StarEditorComponent,
validator: (value: unknown, callback: (valid: boolean) => void) => {
const num = parseInt(String(value), 10);
callback(num >= 1 && num <= 5);
},
},
{ data: 'reviews', type: 'numeric', width: 80 },
{ data: 'price', type: 'numeric', width: 80 },
],
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<example1-rating></example1-rating>
</div>
CSS
.rating-cell {
display: flex;
align-items: center;
margin: 3px 0 0 -1px;
}
.rating-star {
color: var(--ht-background-secondary-color, #e0e0e0);
cursor: default;
display: inline-flex;
align-items: center;
}
.rating-star.active {
color: #facc15;
}
.rating-editor {
display: flex;
align-items: center;
width: 100%;
height: 100%;
box-sizing: border-box !important;
border: none;
border-radius: 0;
box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
var(--ht-cell-editor-border-color, #1a42e8),
0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
var(--ht-cell-editor-shadow-color, transparent);
background-color: var(--ht-cell-editor-background-color, #ffffff);
padding: var(--ht-cell-vertical-padding, 4px) var(--ht-cell-horizontal-padding, 8px);
font-family: inherit;
font-size: inherit;
line-height: inherit;
cursor: pointer;
}
.rating-editor .rating-star {
cursor: pointer;
}
.rating-editor .rating-star.current {
color: var(--ht-accent-color, #1a42e8);
}

Overview

This guide shows how to create an interactive star rating cell using inline SVG stars. Perfect for product ratings, review scores, or any scenario where users need to provide a 1-5 star rating.

Difficulty: Beginner Time: ~15 minutes Libraries: None (pure HTML, SVG and JavaScript)

What You’ll Build

A cell that:

  • Displays 5 SVG stars both when editing and viewing
  • Shows filled stars (gold) and unfilled stars (gray)
  • Uses Handsontable CSS tokens for theme-aware editor styling
  • Supports mouse hover for preview
  • Allows keyboard input (1-5 keys, arrow keys)
  • Provides immediate visual feedback
  • Works without any external libraries

Prerequisites

None! This uses only native HTML, SVG and JavaScript features.

  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { editorFactory } from 'handsontable/editors';
    import { rendererFactory } from 'handsontable/renderers';
    registerAllModules();

    What we’re NOT importing:

    • No icon libraries
    • No UI component libraries
    • No external SVG sprite sheets
    • Handsontable only.
  2. Define the Star SVG

    Create an inline SVG string for the star shape. Using fill="currentColor" allows CSS to control the star color.

    const starSvg =
    '<svg width="1em" height="1em" viewBox="0 0 24 24" fill="currentColor"><path d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"/></svg>';

    What’s happening:

    • width="1em" height="1em" - Stars scale with the font size
    • viewBox="0 0 24 24" - Standard 24x24 coordinate space
    • fill="currentColor" - Inherits the CSS color property, so active/inactive states are controlled via CSS
    • The <path> draws a classic 5-pointed star shape

    Why SVG instead of emoji?

    • Consistent rendering across all browsers and operating systems
    • Full control over color, size, and styling via CSS
    • No platform-dependent emoji variations
    • Crisp at any resolution
  3. Add CSS Styling

    Create a separate CSS file for the rating styles. This uses Handsontable CSS custom properties (tokens) so the editor automatically adapts to custom themes and dark mode.

    .rating-cell {
    display: flex;
    align-items: center;
    margin: 3px 0 0 -1px;
    }
    .rating-star {
    color: var(--ht-background-secondary-color, #e0e0e0);
    cursor: default;
    display: inline-flex;
    align-items: center;
    }
    .rating-star.active {
    color: #facc15;
    }
    .rating-editor {
    display: flex;
    align-items: center;
    width: 100%;
    height: 100%;
    box-sizing: border-box !important;
    border: none;
    border-radius: 0;
    box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
    var(--ht-cell-editor-border-color, #1a42e8),
    0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
    var(--ht-cell-editor-shadow-color, transparent);
    background-color: var(--ht-cell-editor-background-color, #ffffff);
    padding: var(--ht-cell-vertical-padding, 4px)
    var(--ht-cell-horizontal-padding, 8px);
    font-family: inherit;
    font-size: inherit;
    line-height: inherit;
    cursor: pointer;
    }
    .rating-editor .rating-star {
    cursor: pointer;
    }
    .rating-editor .rating-star.current {
    color: var(--ht-accent-color, #1a42e8);
    }

    Cell container:

    • .rating-cell wraps the stars in the renderer with display: flex to match the editor layout
    • margin: 3px 0 0 -1px - Fine-tunes alignment between renderer and editor to prevent visual jump

    Star colors:

    • var(--ht-background-secondary-color, #e0e0e0) - Inactive/unfilled stars (adapts to theme)
    • #facc15 (gold) - Active/filled stars
    • Colors are applied via the CSS color property, which the SVG inherits through fill="currentColor"

    Current star indicator:

    • .rating-editor .rating-star.current highlights the last active star (the one matching the rating value) using --ht-accent-color
    • Makes it clear which star is selected while editing — the current star turns blue (accent color) instead of gold

    Handsontable tokens used:

    • --ht-background-secondary-color - Inactive star color (adapts to theme)
    • --ht-accent-color - Current star highlight in editor (blue)
    • --ht-cell-editor-border-color / --ht-cell-editor-border-width - blue border matching native editors
    • --ht-cell-editor-background-color - editor background
    • --ht-cell-editor-shadow-blur-radius / --ht-cell-editor-shadow-color - editor shadow
    • --ht-cell-vertical-padding / --ht-cell-horizontal-padding - consistent cell padding matching the renderer
  4. Create the Renderer

    The renderer displays 5 SVG stars wrapped in a flex container using CSS classes for color control.

    renderer: rendererFactory(({ td, value }) => {
    td.innerHTML = `<div class="rating-cell">${Array.from(
    { length: 5 },
    (_, index) =>
    `<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`
    ).join('')}</div>`;
    })

    What’s happening:

    • Stars are wrapped in a <div class="rating-cell"> flex container to match the editor’s flex layout
    • Array.from({ length: 5 }) - Creates an array with 5 elements (indices 0-4)
    • index < value - Stars up to the rating value get the active class (gold color)
    • index >= value - Stars beyond the rating stay gray via CSS
    • Each span contains the inline SVG star
    • join('') - Concatenates all star spans into a single string
  5. Create the Validator

    Ensure values are within the valid range.

    validator: (value, callback) => {
    value = parseInt(value);
    callback(value >= 0 && value <= 100);
    }

    What’s happening:

    • Convert value to integer (keyboard input returns strings)
    • Validate the value is within the acceptable range
    • Call callback(true) for valid, callback(false) for invalid
  6. Editor - Initialize (init)

    Create the container div for the star rating editor.

    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('DIV') as HTMLDivElement;
    editor.input.classList.add('rating-editor');
    }

    What’s happening:

    1. Create a div container for the star buttons
    2. Add the rating-editor CSS class (all styling is in the CSS file)
    3. This container will hold the 5 SVG star elements

    Key styling (from CSS):

    • display: flex; align-items: center - Stars aligned vertically
    • box-shadow with --ht-cell-editor-border-color - Blue border matching native editors
    • padding with cell padding tokens - Matches renderer to prevent visual jump
    • font-family/font-size/line-height: inherit - Consistent sizing with the cell
  7. Editor - After Init Hook (afterInit)

    Set up mouse events for hover preview and click selection.

    afterInit(editor) {
    editor.input.addEventListener('mouseover', (event) => {
    const star = (event.target as HTMLElement).closest('.rating-star') as HTMLElement | null;
    if (
    star?.dataset.value &&
    parseInt(editor.value) !== parseInt(star.dataset.value)
    ) {
    editor.setValue(star.dataset.value);
    }
    });
    editor.input.addEventListener('mousedown', () => {
    editor.finishEditing();
    });
    }

    What’s happening:

    Mouseover Event:

    1. User hovers over a star (or its SVG child element)
    2. Use closest('.rating-star') to find the parent span — this is important because the hover target may be the SVG <path> element inside the span
    3. Get the hover rating from the span’s dataset.value
    4. If different from current value, update it
    5. This creates a “preview” effect as user hovers

    Mousedown Event:

    1. User clicks (mousedown) anywhere in the editor
    2. Finish editing immediately
    3. Value is saved to the cell

    Why closest() instead of checking event.target directly?

    • With inline SVGs, the actual hover/click target is often the <svg> or <path> element, not the parent <span>
    • closest('.rating-star') walks up the DOM tree to find the span with the data-value attribute
    • This ensures reliable star detection regardless of which SVG child element the user interacts with
  8. Editor - Render Function (render)

    Generate the HTML for the 5 star buttons based on current rating.

    render(editor) {
    editor.input.innerHTML = Array.from(
    { length: 5 },
    (_, index) =>
    `<span data-value="${index + 1}" class="rating-star ${
    index < editor.value ? 'active' : ''
    }${index + 1 === parseInt(editor.value) ? ' current' : ''}">${starSvg}</span>`
    ).join('');
    }

    What’s happening:

    1. Create 5 star spans (indices 0-4, values 1-5)
    2. Each span has data-value attribute with rating (1-5)
    3. Stars use the rating-star class for base styling (gray color)
    4. Active stars get the active class (gold color)
    5. The star matching the current value gets the current class (accent color) — this highlights the selected rating in the editor
    6. Each span contains the inline SVG star
    7. Join all spans into a single HTML string

    Dynamic rendering:

    • Updates whenever editor.setValue() is called
    • Automatically called by editorFactory when value changes
    • Provides live preview as user interacts
  9. Editor - Keyboard Shortcuts

    Add keyboard support for rating selection.

    shortcuts: [
    {
    keys: [['1'], ['2'], ['3'], ['4'], ['5']],
    callback: (editor, _event) => {
    editor.setValue((_event as KeyboardEvent).key);
    }
    },
    {
    keys: [['ArrowRight']],
    callback: (editor, _event) => {
    if (parseInt(editor.value) < 5) {
    editor.setValue(parseInt(editor.value) + 1);
    }
    }
    },
    {
    keys: [['ArrowLeft']],
    callback: (editor, _event) => {
    if (parseInt(editor.value) > 1) {
    editor.setValue(parseInt(editor.value) - 1);
    }
    }
    }
    ]

    What’s happening:

    Number Keys (1-5):

    • Press 1-5 to set rating directly
    • Fastest way to select a specific rating
    • Gets key value from keyboard event

    Arrow Keys:

    • ArrowRight: Increase rating (max 5)
    • ArrowLeft: Decrease rating (min 1)
    • Bounded within valid range
    • Smooth incremental adjustment

    Keyboard navigation benefits:

    • Fast selection without mouse
    • Accessible for keyboard-only users
    • Number keys for direct selection, arrows for adjustment
  10. Complete Cell Definition

    const starSvg =
    '<svg width="1em" height="1em" viewBox="0 0 24 24" fill="currentColor"><path d="M12 2l3.09 6.26L22 9.27l-5 4.87 1.18 6.88L12 17.77l-6.18 3.25L7 14.14 2 9.27l6.91-1.01L12 2z"/></svg>';
    const cellDefinition = {
    renderer: rendererFactory(({ td, value }) => {
    td.innerHTML = `<div class="rating-cell">${Array.from(
    { length: 5 },
    (_, index) =>
    `<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`
    ).join('')}</div>`;
    }),
    validator: (value, callback) => {
    value = parseInt(value);
    callback(value >= 0 && value <= 100);
    },
    editor: editorFactory<{ input: HTMLDivElement }>({
    shortcuts: [
    {
    keys: [['1'], ['2'], ['3'], ['4'], ['5']],
    callback: (editor, _event) => {
    editor.setValue((_event as KeyboardEvent).key);
    },
    },
    {
    keys: [['ArrowRight']],
    callback: (editor, _event) => {
    if (parseInt(editor.value) < 5) {
    editor.setValue(parseInt(editor.value) + 1);
    }
    },
    },
    {
    keys: [['ArrowLeft']],
    callback: (editor, _event) => {
    if (parseInt(editor.value) > 1) {
    editor.setValue(parseInt(editor.value) - 1);
    }
    },
    },
    ],
    init(editor) {
    editor.input = editor.hot.rootDocument.createElement(
    'DIV'
    ) as HTMLDivElement;
    editor.input.classList.add('rating-editor');
    },
    afterInit(editor) {
    editor.input.addEventListener('mouseover', (event) => {
    const star = (event.target as HTMLElement).closest(
    '.rating-star'
    ) as HTMLElement | null;
    if (
    star?.dataset.value &&
    parseInt(editor.value) !== parseInt(star.dataset.value)
    ) {
    editor.setValue(star.dataset.value);
    }
    });
    editor.input.addEventListener('mousedown', () => {
    editor.finishEditing();
    });
    },
    render(editor) {
    editor.input.innerHTML = Array.from(
    { length: 5 },
    (_, index) =>
    `<span data-value="${index + 1}" class="rating-star ${
    index < editor.value ? 'active' : ''
    }${index + 1 === parseInt(editor.value) ? ' current' : ''}">${starSvg}</span>`
    ).join('');
    },
    }),
    };

    What’s happening:

    • starSvg: Inline SVG star with fill="currentColor" for CSS color control
    • renderer: Displays 5 SVG stars wrapped in a .rating-cell flex container with CSS class-based coloring (gold/gray)
    • validator: Ensures rating is within valid range
    • editor: Uses editorFactory helper with:
      • Keyboard shortcuts for 1-5 keys and arrow keys
      • Container initialization with rating-editor CSS class
      • Mouse events using closest() for reliable SVG hover detection
      • Render function with current class to highlight the selected star using accent color
  11. Use in Handsontable

    const container = document.querySelector('#example1')!;
    const hotOptions: Handsontable.GridSettings = {
    data,
    colHeaders: ['Product', 'Category', 'Rating', 'Reviews', 'Price'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    autoWrapRow: true,
    headerClassName: 'htLeft',
    columns: [
    { data: 'product', type: 'text', width: 240 },
    { data: 'category', type: 'text', width: 120 },
    { data: 'rating', width: 150, ...cellDefinition },
    { data: 'reviews', type: 'numeric', width: 80 },
    { data: 'price', type: 'numeric', width: 80 },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    Key configuration:

    • ...cellDefinition - Spreads the renderer, validator, and editor onto the Rating column
    • headerClassName: 'htLeft' - Left-aligns all column headers
    • width: '100%' - Table fills the container width

How It Works - Complete Flow

  1. Initial Render: Cell displays 5 SVG stars — gold for filled, gray for unfilled
  2. User Double-Clicks or Enter: Editor opens over cell showing interactive stars with Handsontable blue border
  3. Current Star Indicator: The last active star turns blue (accent color) to clearly show the selected rating
  4. Mouse Hover: User hovers over stars → preview rating updates in real-time (detected via closest())
  5. Click Selection: User clicks → rating selected and editor closes
  6. Keyboard Input: User presses 1-5 keys → rating set directly
  7. Arrow Navigation: User presses ArrowLeft/ArrowRight → rating increments/decrements
  8. Validation: Validator checks the value is valid
  9. Save: Valid value saved to cell
  10. Editor Closes: Cell shows updated star rating

Enhancements

  1. Show Numeric Value

    Display the numeric rating alongside stars:

    renderer: rendererFactory(({ td, value }) => {
    const stars = Array.from({ length: 5 }, (_, index) =>
    `<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`
    ).join('');
    td.innerHTML = `
    <div style="display: flex; align-items: center; gap: 8px;">
    <span>${stars}</span>
    <span style="font-weight: bold; color: #666;">${value}/5</span>
    </div>
    `;
    })
  2. Custom Star Count

    Configurable number of stars per column:

    renderer: rendererFactory(({ td, value, cellProperties }) => {
    const maxStars = cellProperties.maxStars || 5;
    td.innerHTML = Array.from({ length: maxStars }, (_, index) =>
    `<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`
    ).join('');
    })
    // Usage
    columns: [{
    data: 'rating',
    ...cellDefinition,
    maxStars: 10 // 10-star rating
    }]
  3. Text Labels

    Add text labels like “Excellent”, “Good”, etc.:

    renderer: rendererFactory(({ td, value }) => {
    const labels = ['', 'Poor', 'Fair', 'Good', 'Very Good', 'Excellent'];
    const label = labels[value] || '';
    const stars = Array.from({ length: 5 }, (_, index) =>
    `<span class="rating-star ${index < value ? 'active' : ''}">${starSvg}</span>`
    ).join('');
    td.innerHTML = `
    <div style="display: flex; align-items: center; gap: 8px;">
    <span>${stars}</span>
    <span style="font-size: 0.9em; color: #666;">${label}</span>
    </div>
    `;
    })
  4. Custom Star Colors

    Change colors by overriding CSS for specific columns:

    /* Red/green rating */
    .custom-rating .rating-star {
    color: #e5e7eb;
    }
    .custom-rating .rating-star.active {
    color: #22c55e;
    }

Accessibility

Keyboard navigation:

  • Number keys (1-5): Direct rating selection
  • ArrowRight: Increase rating (max 5)
  • ArrowLeft: Decrease rating (min 1)
  • Enter: Confirm selection and finish editing
  • Escape: Cancel editing

What you learned

You built an SVG star rating cell using editorFactory and rendererFactory. You used Handsontable CSS tokens for theme-aware styling, closest() for reliable hover detection on inline SVG elements, and keyboard shortcuts for direct number-key and arrow-key selection.

Next steps

  • Star Rating (React) - The same concept using React’s EditorComponent and a local star rating component.
  • Star Rating Editor (Angular) - The Angular version using HotCellEditorAdvancedComponent.
  • Feedback - Another no-library custom editor using editorFactory and CSS tokens.